###*
# Contains all timers.
# @type {{}}
###

timers = {}

###*
# Timers factory object.
# @param name
# @returns {*}
###

getTimer = (name) ->
  unless timers[name]?
    timers[name] =
      _total: 0
      _count: 0
      _min: null
      _max: null
      mean: ->
        @_total / @_count
      duration: ->
        @_total
      min: ->
        @_min
      max: ->
        @_max
      count: ->
        @_count
      parse: (num) ->
        if num < 1e3
          return num + 'ns'
        else if num >= 1e3 and num < 1e6
          return num / 1e3 + 'us'
        else if num >= 1e6 and num < 1e9
          return num / 1e6 + 'ms'
        else if num >= 1e9
          return num / 1e9 + 's'

      addTick: (dur) ->
        @_count++
        @_max = Math.max dur, (if @_max? then @_max else -Infinity)
        @_min = Math.min dur, (if @_min? then @_min else Infinity)
        @_total += dur
        dur

  timers[name]

###*
# Starts the tick.
###

###*
# Constructor of tick.
# @param name The name of this tick.
# @returns {Tick}
# @constructor
###

Tick = (name) ->
  @name = name
  this

###*
# Ends the tick.
###
Tick::start = ->
  @start = new Date

Tick::stop = ->
  @stop = new Date
  getTimer(@name).addTick(@stop - @start)

Tick::getDiff = ->
  @stop - @start

module.exports =
  timers: timers
  Tick: Tick
  statsRoute: ->
    (req,res) ->

      payload = {timers:{}, status: "ok"}
      for name,timer of timers
        payload.timers[name] =
          count:  timer.count()
          min:    Math.round timer.min()
          max:    Math.round timer.max()
          mean:   Math.round timer.mean()

      res.json payload


# ---
# generated by js2coffee 2.0.4